package domain;
;#####################################################################
;#
;# domain.pl: Perl library for Domain Converter
;#
;# Copyright(c)1998-2001 saya yuikawa allright resered
;#    <yuikawa@imasy.or.jp>
;#
;# Copyright(c)1998-2001 arimi minakami allright resered
;#    <arimi@wendy-net.org>
;#
$version = '1.16.53';
;#  Last Update:2001.03.24
;#
;# Support WebPage
;#      http://www.imasy.or.jp/~yuikawa/saya/
;#
;#####################################################################
;#
;# INTERFACE:
;#
;#     &domain'top_domain($domain_name)
;#     &domain'top_domain(@domain_name)
;#          consult part name (list) from top domain name
;#          Return value 0 if failed.
;#
;#     &domain'jp_domain($jp_domain)
;#     &domain'jp_domain(@jp_domain)
;#          consult organization name (list) 
;#               from second domain name of japan
;#          Return value $jp_domain / @jp_domain if failed.
;#
;#     &domain'domain_lay($line);
;#          consult count from top domain name to peculiar domain name
;#
;#     &domain'host($remote_host);
;#     &domain'host(@remote_host);
;#          consult domain name (list) to remote host name
;#
;#     &domain'version;
;#          consult version of this file
;#
;#     &domain'list_top_domain;
;#
;#     &domain'list_ae;
;#     &domain'list_ar;
;#     &domain'list_at;
;#     &domain'list_au;
;#     &domain'list_br;
;#     &domain'list_cn;
;#     &domain'list_co;
;#     &domain'list_ee;
;#     &domain'list_fk;
;#     &domain'list_gu;
;#     &domain'list_il;
;#     &domain'list_in;
;#     &domain'list_io;
;#     &domain'list_jp;
;#     &domain'list_kr;
;#     &domain'list_mk;
;#     &domain'list_mt;
;#     &domain'list_np;
;#     &domain'list_ph;
;#     &domain'list_pk;
;#     &domain'list_pl;
;#     &domain'list_sa;
;#     &domain'list_sg;
;#     &domain'list_tr;
;#     &domain'list_tw;
;#     &domain'list_uk;
;#     &domain'list_za;
;#     &domain'list_zw;
;#
;#     &domain'list_lay;
;#
;#
;#
;#
;# EXAMPLE:
;#
;#     $domain_name ='jp';
;#     $domain = &domain'top_domain($domain_name);
;#
;#     @domain_name = ('jm', 'JO', 'jp', 'fake_domain');
;#     $domain = &domain'top_domain(@domain_name);
;#
;#     $jp_domain ='co';
;#     $domain_jp = &domain'jp_domain($jp_domain);
;#
;#     @jp_domain = ('co', 'ne', 'fake_domain');
;#     @domain_jp = &domain'jp_domain(@jp_domain);
;#
;#     $line ='jp';
;#     $domain_line = &domain'domain_lay($line);
;#
;#     $remote_host ='pop13.imasy.or.jp';
;#     $domain_host = &domain'host($remote_host);
;#
;#     @remote_host = 
;#         ('pop13.imasy.or.jp', 'pop14.imasy.org', '123.456.789.10');
;#     $domain_host = &domain'host(@remote_host);
;#
;#   result:
;#     $domain = 'japan';
;#     @domain = ('Jamaica', 'Jordan', 'Japan', '0');
;#     $domain_jp = 'company';
;#     @domain_jp = ('company', 'network', 'fake_domain');
;#     $domain_line = 2;
;#     $domain_host ='imasy.or.jp';
;#     @domain_host =('imasy.or.jp', 'imasy.org', '123.456.789.10');
;#
;#
;#####################################################################


sub top_domain {
   %list_top = &list_top;
   $top_domain = \%list_top;
   undef @domain;
   $domain_list = \@domain;

   foreach (@_) {
      if (exists($$top_domain{"\L$_\E"})) {
         push(@$domain_list, $$top_domain{"\L$_\E"});
      }
      else {
         push(@$domain_list, 0);
      }
   }

   return ($#{$domain_list} == 0) ? $$domain_list[0] : @$domain_list;
}



sub jp_domain {
   %list_jp = &list_jp;
   $jp_domain = \%list_jp;
   undef @domain;
   $domain_list = \@domain;

   foreach (@_) {
      push(@$domain_list, exists($$jp_domain{"\L$_\E"}) ? $$jp_domain{"\L$_\E"} : $_);
   }

   return ($#{$domain_list} == 0) ? $$domain_list[0] : @$domain_list;
}


sub jp_domain2 {
   %list_jp = &list_jp;
   $jp_domain = \%list_jp;
   undef @domain;
   $domain_list = \@domain;

   foreach (@_) {

      if ($_ !~ /^\d+\.\d+\.\d+\.\d+$/) {
         @line = split(/\./, $_);
         $tip = \$line[($#line - 1)];
         push(@$domain_list, exists($$jp_domain{"\L$$tip\E"}) ? $$jp_domain{"\L$$tip\E"} : $$tip);
      }
      else {
         push (@$domain_list, $_);
      }
   }

   return ($#{$domain_list} == 0) ? $$domain_list[0] : @$domain_list;
}



sub jpsecond_domain {# ̕ύXɂ̂폜
   %list_jp = &list_jp;
   $jp_domain = \%list_jp;
   undef @domain;
   $domain_list = \@domain;

   foreach (@_) {
      if (exists($$jp_domain{"\L$_\E"})) {
         push(@$domain_list, $$jp_domain{"\L$_\E"});
      }
      else {
         push(@$domain_list, 0);
      }
   }

   return ($#{$domain_list} == 0) ? $$domain_list[0] : @$domain_list;
}


sub domain_lay {# ̂폜?
   %list_lay = &list_lay;
   $domain_lay = \%list_lay;
   undef @domain;
   $domain_list = \@domain;

   if (exists($$domain_lay{"\L$_\E"})) {
      push(@$domain_list, $$domain_lay{"\L$_\E"});
   }
   else {
      push(@$domain_list, 0);
   }
}


sub host {
   my @host_list;
   %list_lay = &list_lay;
   $domain_lay = \%list_lay;
   $host_list = \@host_list;

   foreach (@_) {
      @host_data = split(/\./, "$_");

      if (exists($$domain_lay{"\L$host_data[$#host_data]\E"})) {
         push(@$host_list, join(".", splice(@host_data, $#host_data - $$domain_lay{"\L$host_data[$#host_data]\E"})));
      }
      else {
         push(@$host_list, $_);
      }
   }

   return ($#{$host_list} == 0) ? $$host_list[0] : @$host_list;
}


sub sub_host {# don't use!!
   %list_lay = &list_lay;
   $domain_lay = \%list_lay;
   undef @domain;
   $host_list = \@host;

   foreach (@_) {
      if ($_ !~ /^\d+\.\d+\.\d+\.\d+$/) {
         @host_data = split(/\./, $_);
         $delline = 0;

     #    if ($host_data[2] eq "ocn") {# ocn 
         if (index($host_data[2], 'ocn') != -1) {
            $host_data[0] =~ s/^\w{1,3}\d+-\w{1,3}\d\d?//;
            if ($host_data[0] =~ /^\w+\d$/) {
               push(@$host_list, join(".", splice(@host_data, 1)));
               next;
            }
            push(@$host_list, join(".", splice(@host_data, 0)));
            next;
         }
      #   if ($host_data[3] eq "so-net") {# so-net 
         if (index($host_data[3], 'so-net') != -1) {
            $host_data[1] =~ s/\d+$//;
            push(@$host_list, join(".", splice(@host_data, 1)));
            next;
         }

         $loop = (exists($$domain_lay{"\L$host_data[$#host_data]\E"})) ? ($#host_data - $$domain_lay{"\L$host_data[$#host_data]\E"}) : 1;
         $i = 0;
      #   if ($host_data[$i] =~ /^proxy|cache|dialup/) {
         if (index($host_data[$i], 'proxy')  != -1 || index($host_data[$i], 'cache') != -1 || index($host_data[$i], 'dialup') != -1) {
            ++$delline;
            ++$i;
         }
         for ($i = $i; $i < $loop; $i++) {
            if (length($host_data[$i]) < 3) {
               ++$delline;
            }
            elsif ($host_data[$i] =~ /^ppp|\w+\d|\w+\-\w*\d/) {
               ++$delline;
            }
            else {
               last;
            }
         }
         push(@$host_list, join(".", splice(@host_data, $delline)));
      }
      else {
         push(@$host_list, $_);
      }
   }

   return ($#{$host_list} == 0) ? $$host_list[0] : @$host_list;
}


sub version {
   return $version;
}


sub list_top {

('arpa', 'Arpanet',
'com', 'Commercial',
'edu', 'Education',
'gov', 'Government',
'int', 'International',
'mil', 'Military',
'nato', 'NATO',
'net', 'Network',
'org', 'Organization',

'firm', 'Businesses or Firms',
'shop', 'Goods to Purchase',
'web', 'for entities emphasizing activities related to the WWW',
'arts', 'Cultural & Entertainment',
'rec', 'Recreational Activities',
'info', 'Informational Services',
'nom', 'Personal Names',

'aero', 'Air-transport industry',
'biz', 'Businesses',
'coop', 'Non-profit cooperatives',
'info', 'Unrestricted use',
'museum', 'Museums',
'name', 'For registration by individuals',
'pro', 'Accountants, lawyers, and physicians',


'ac', 'Ascension Island',
'ad', 'Andorra',
'ae', 'United Arab Emirates',
'af', 'Afghanistan',
'ag', 'Antigua and Barbuda',
'ai', 'Anguilla',
'al', 'Albania',
'am', 'Armenia',
'an', 'Netherlands Antilles',
'ao', 'Angola',
'aq', 'Antarctica',
'ar', 'Argentina',
'as', 'American Samoa',
'at', 'Austria',
'au', 'Australia',
'aw', 'Aruba',
'az', 'Azerbaidjan',

'ba', 'Bosnia-Herzegovina',
'bb', 'Barbados',
'bd', 'Bangladesh',
'be', 'Belgium',
'bf', 'Burkina Faso',
'bg', 'Bulgaria',
'bh', 'Bahrain',
'bi', 'Burundi',
'bj', 'Benin',
'bm', 'Bermuda',
'bn', 'Brunei Darussalam',
'bo', 'Bolivia',
'br', 'Brazil',
'bs', 'Bahamas',
'bt', 'Bhutan',
'bv', 'Bouvet Island',
'bw', 'Botswana',
'by', 'Belarus',
'bz', 'Belize',

'ca', 'Canada',
'cc', 'Cocos (Keeling) Islands',
'cd', 'Congo\, The Democratic Republic of The Congo', 
'cf', 'Central African Republic',
'cg', 'Congo',
'ch', 'Switzerland',
'ci', 'Ivory Coast (Cote D\'Ivoire)',
'ck', 'Cook Islands',
'cl', 'Chile',
'cm', 'Cameroon',
'cn', 'China',
'co', 'Colombia',
'cr', 'Costa Rica',
'cs', 'Former Czechoslovakia',
'cu', 'Cuba',
'cv', 'Cape Verde',
'cx', 'Christmas Island',
'cy', 'Cyprus',
'cz', 'Czech Republic',

'de', 'Germany',
'dj', 'Djibouti',
'dk', 'Denmark',
'dm', 'Dominica',
'do', 'Dominican Republic',
'dz', 'Algeria',

'ec', 'Ecuador',
'ee', 'Estonia',
'eg', 'Egypt',
'eh', 'Western Sahara',
'er', 'Eritrea',
'es', 'Spain',
'et', 'Ethiopia',

'fi', 'Finland',
'fj', 'Fiji',
'fk', 'Falkland Islands (Malvinas)',
'fm', 'Micronesia',
'fo', 'Faroe Islands',
'fr', 'France',
'fx', 'France (European Territory)',

'ga', 'Gabon',
'gb', 'Great Britain',
'gd', 'Grenada',
'ge', 'Georgia',
'gf', 'French Guyana',
'gh', 'Ghana',
'gi', 'Gibraltar',
'gl', 'Greenland',
'gm', 'Gambia',
'gn', 'Guinea',
'gp', 'Guadeloupe (French)',
'gq', 'Equatorial Guinea',
'gr', 'Greece',
'gs', 'S. Georgia & S. Sandwich Isls.',
'gt', 'Guatemala',
'gu', 'Guam (USA)',
'gw', 'Guinea Bissau',
'gy', 'Guyana',

'hk', 'Hong Kong',
'hm', 'Heard and McDonald Islands',
'hn', 'Honduras',
'hr', 'Croatia',
'ht', 'Haiti',
'hu', 'Hungary',

'id', 'Indonesia',
'ie', 'Ireland',
'il', 'Israel',
'in', 'India',
'io', 'British Indian Ocean Territory',
'iq', 'Iraq',
'ir', 'Iran',
'is', 'Iceland',
'it', 'Italy',

'jm', 'Jamaica',
'jo', 'Jordan',
'jp', 'Japan',

'ke', 'Kenya',
'kg', 'Kyrgyzstan',
'kh', 'Cambodia',
'ki', 'Kiribati',
'km', 'Comoros',
'kn', 'Saint Kitts & Nevis Anguilla',
'kp', 'North Korea',
'kr', 'South Korea',
'kw', 'Kuwait',
'ky', 'Cayman Islands',
'kz', 'Kazakhstan',

'la', 'Laos',
'lb', 'Lebanon',
'lc', 'Saint Lucia',
'li', 'Liechtenstein',
'lk', 'Sri Lanka',
'lr', 'Liberia',
'ls', 'Lesotho',
'lt', 'Lithuania',
'lu', 'Luxembourg',
'lv', 'Latvia',
'ly', 'Libya',

'ma', 'Morocco',
'mc', 'Monaco',
'md', 'Moldavia',
'mg', 'Madagascar',
'mh', 'Marshall Islands',
'mk', 'Macedonia',
'ml', 'Mali',
'mm', 'Myanmar',
'mn', 'Mongolia',
'mo', 'Macau',
'mp', 'Northern Mariana Islands',
'mq', 'Martinique (French)',
'mr', 'Mauritania',
'ms', 'Montserrat',
'mt', 'Malta',
'mu', 'Mauritius',
'mv', 'Maldives',
'mw', 'Malawi',
'mx', 'Mexico',
'my', 'Malaysia',
'mz', 'Mozambique',

'na', 'Namibia',
'nc', 'New Caledonia (French)',
'ne', 'Niger',
'nf', 'Norfolk Island',
'ng', 'Nigeria',
'ni', 'Nicaragua',
'nl', 'Netherlands',
'no', 'Norway',
'np', 'Nepal',
'nr', 'Nauru',
'nt', 'Neutral Zone',
'nu', 'Niue',
'nz', 'New Zealand',

'om', 'Oman',

'pa', 'Panama',
'pe', 'Peru',
'pf', 'Polynesia (French)',
'pg', 'Papua New Guinea',
'ph', 'Philippines',
'pk', 'Pakistan',
'pl', 'Poland',
'pm', 'Saint Pierre and Miquelon',
'pn', 'Pitcairn Island',
'pr', 'Puerto Rico',
'pt', 'Portugal',
'pw', 'Palau',
'py', 'Paraguay',

'qa', 'Qatar',

're', 'Reunion (French)',
'ro', 'Romania',
'ru', 'Russian Federation',
'rw', 'Rwanda',

'sa', 'Saudi Arabia',
'sb', 'Solomon Islands',
'sc', 'Seychelles',
'sd', 'Sudan',
'se', 'Sweden',
'sg', 'Singapore',
'sh', 'Saint Helena',
'si', 'Slovenia',
'sj', 'Svalbard and Jan Mayen Islands',
'sk', 'Slovak Republic',
'sl', 'Sierra Leone',
'sm', 'San Marino',
'sn', 'Senegal',
'so', 'Somalia',
'sr', 'Suriname',
'st', 'Saint Tome and Principe',
'su', 'Former USSR',
'sv', 'El Salvador',
'sy', 'Syria',
'sz', 'Swaziland',

'tc', 'Turks and Caicos Islands',
'td', 'Chad',
'tf', 'French Southern Territories',
'tg', 'Togo',
'th', 'Thailand',
'tj', 'Tadjikistan',
'tk', 'Tokelau',
'tm', 'Turkmenistan',
'tn', 'Tunisia',
'to', 'Tonga',
'tp', 'East Timor',
'tr', 'Turkey',
'tt', 'Trinidad and Tobago',
'tv', 'Tuvalu',
'tw', 'Taiwan',
'tz', 'Tanzania',

'ua', 'Ukraine',
'ug', 'Uganda',
'uk', 'United Kingdom',
'um', 'USA Minor Outlying Islands',
'us', 'United States',
'uy', 'Uruguay',
'uz', 'Uzbekistan',

'va', 'Vatican City State',
'vc', 'Saint Vincent & Grenadines',
've', 'Venezuela',
'vg', 'Virgin Islands (British)',
'vi', 'Virgin Islands (USA)',
'vn', 'Vietnam',
'vu', 'Vanuatu',

'wf', 'Wallis and Futuna Islands',
'ws', 'Samoa',

'ye', 'Yemen',
'yt', 'Mayotte',
'yu', 'Yugoslavia',

'za', 'South Africa',
'zm', 'Zambia',
'zr', 'Zaire',
'zw', 'Zimbabwe'
);
}


sub list_ae {# _domain
   ('net', 'Network');
}


sub list_ar {# _domain
   ('com', 'Commercial',
   'edu', 'Education',
   'gov', 'Government');
}


sub list_at {
   ('ac', 'Academy',
   'co', 'Company',
   'or', 'Organization',
   'gv', '');
}


sub list_au {
   ('com', 'Commercial Entities',
   'edu', 'Educational Institutions',
   'gov', 'Government and Semi-Government Entities',
   'org', 'Various Forms of Affiliation Groups',
   'id', 'Individual Zones',
   'oz', 'entities which are visible within the ACSnet domain',
   'info', 'major Australian Informational and Service Resources',
   'net', 'Network Infrastructure and Providers',
   'asn', 'Associations',
   'csiro', 'CSIRO',
   'telememo', 'naming X.400 Entities',
   'conf', 'Conferences and Exhibitions');
}


sub list_bo {
   ('com', 'Commercial',
   'edu', 'Education',
   'gov', 'Government',
   'org', 'Organization');
}


sub list_br {# _domain
   ('com', 'Commercial');
}


sub list_cn {# _domain
   ('net', 'Network',
   'sh', '');# fj
}


sub list_co {# _domain
   ('com', 'Commercial',
   'edu', 'Education',
   'net', 'Network');
}


sub list_ee {
   ('edu', 'Schools and other Educational institutions',
   'com', 'Commercial institutions',
   'org', 'Non-profit Organizations and Societies',
   'pri', 'Private persons');
}


sub list_fk {
   ('ac', 'Academic',
   'co', 'Commercial',
   'gov', 'Government',
   'net', 'Network',
   'nom', 'Personal',
   'org', 'Non-Commercial');
}

sub list_gu {# _domain
   ('gov', 'Government');
}

sub list_hk {
   ('com', 'Commercial Entity with Business Registration',
   'org', 'Miscellaneous Organization (non-profit)',
   'net', 'Internet Access Providers',
   'edu', 'Education Department and higher institutions',
   'gov', 'Government Departments');
}

sub list_id {
   ('ac', 'Academic',
   'co', 'Commercial',
   'go', 'Government',
   'mil', 'Military',
   'or', 'Organization',
   'web', 'World Wide Web');
}

sub list_il {
   ('k12', 'Kindergartens, Elementary Schools, and High Schools (Ministry of Education classification)',
   'org', 'Non-Commercial Organizations',
   'ac', 'Academic Institutions of Higher Education',
   'gov', 'Governmental Organizations',
   'muni', 'Municipal and Local Government Authorities',
   'net', 'Internet Service Providers',
   'co', 'Commercial organizations',
   'idf', 'Israel Military Entities');
}


sub list_in {# _domain
   ('ernet', '?');
}


sub list_io {
   ('com', 'BIOT commercial, for-profit organizations',
   'org', 'BIOT miscellaneous, usually, non-profit organizations',
   'net', 'BIOT network infrastructure machines and organizations',
   'gov', 'BIOT national and local government agencies',
   'mil', 'Defence establishments on BIOT.',
   'edu', 'Educational establishments on BIOT');
}



sub list_jp {
   ('ac', 'Academic',
   'ad', 'Administration',
   'co', 'Company',
   'ed', 'Education',
   'go', 'Government',
   'gr', 'Group',
   'ne', 'Network',
   'or', 'Organization',

   'kek', 'High Energy Accelerator Research Organization',
   'ntt', 'Nippon Telegraph and Telephone Corporation'
);
}


sub list_kr {# _domain
   ('ac', 'Academy',
   'co', 'Commercial',
   'ne', 'Network');
}


sub list_mk {# _domain
   ('com', 'Commercial');
}


sub list_mt {
   ('com', 'Network');
}


sub list_np {
   ('net', 'Commercial',
   'org', 'Organizations',
   'edu', 'Education',
   'net', 'Network',
   'gov', 'Government');
}


sub list_nz {
   ('ac', 'Academic',
   'co', 'Commercial',
   'gen', 'Individual',
   'govt', 'Government',
   'mil', 'Military',
   'net', 'Network',
   'org', 'Not for profit',
   'school', 'School');
}


sub list_ph {
   ('com', 'Commercial',
   'net', 'Network',
   'org', 'Organizat',
   'mil', 'Military',
   'ngo', 'Non-Government Organisation');
}

sub list_pk {
   ('com', 'General Business or Individual',
   'net', 'Network Related Business',
   'edu', 'Educational Institutes',
   'org', 'Non-profit Organizations',
   'fam', 'Family and Individuals',
   'biz', 'General Business, Promotional',
   'web', 'Web Sites',
   'gov', 'Government of Pakistan',
   'gob', 'Government of Baluchistan',
   'gok', 'Government of Azad Kashmir',
   'gon', 'Government of NWFP',
   'gop', 'Government of Punjab',
   'gos', 'Government of Sindh');
}

sub list_pl {
   ('edu', 'Education',
   'com', 'Commercial',
   'net', 'Network',
   'org', 'Organization',
   'waw', 'waw');
}


sub list_py {
   ('com', 'Commercial',
   'edu', 'Education',
   'mil', 'Military',
   'org', 'Organization',
   'gov', 'Reservado solamente para instituciones gubernamentales.', # I can't read!!
   'net', 'Solamente a aquellas empresas que prestan servicios de acceso a INTERNET.');# I can't read!!
}

sub list_sa {
   ('com', 'Commercial entities',
   'edu', 'Educational institutions',
   'sch', 'Kindergartens, Elementary schools, Secondary schools, and High schools',
   'med', 'Hospitals and Medical Clinics',
   'gov', 'Governmental Organizations',
   'net', 'Internet Service Providers',
   'org', 'Non-profit Organizations', 
   'pub', 'Others');
}


sub list_sg {
   ('com', 'Commercial',
   'net', 'Network Providers',
   'org', '"Not-for-profit" Organization',
   'gov', 'all Government Organizations.',
   'edu', 'Educational Institutions.');
}


sub list_th {
   ('co', 'Commercial Entities and Business Entities',
   'ac', 'Academic institutions',
   'go', 'Government',
   'net', 'Internet or Network Service Providers',
   'or', 'non-Profit Organization',
   'mi', 'military');
}


sub list_tr {# I can't read language of this conuntry.
   ('bbs', 'bbs',
   'com', 'commercial',
   'edu', 'education',
   'gen', 'general', # ?
   'gov', 'Goverment',
   'k12', 'k12',
   'mil', 'miltary',
   'net', 'Internet service',
   'nom', 'Persona',
   'org', 'organization');
}


sub list_tw {
   ('edu', 'Educational, Academic and Research Organizations',
   'gov', 'Government Agencies',
   'com', 'Commercial Organizations',
   'net', 'Internet Management Organization',
   'org', 'Foundational, Judicial Persons and such non-government, nonprofit organizations',
   'mil', 'National defense and military organizations');
}


sub list_uk {
   ('ac', 'Academy',
   'co', 'Commercial',
   'org', 'Non-Commercial Organisations',
   'net', 'for the host machines of ISPs',
   'ltd', 'for use by Registered Companies only',
   'plc', 'for use by Registered Companies only');
}


sub list_vn {# _domain
   ('com', 'Commercial');
}


sub list_za {
   ('ac', 'South African Research and Academic institutions',
   'alt', 'definition not yet available',
   'city', 'Local and related Authorities',
   'co', 'Commercial Organizations',
   'edu', 'learning organization',
   'gov', 'Government departments',
   'law', 'Legal profession',
   'mil', 'Military Establishments',
   'net', 'Internet Service Providers',
   'ngo', 'Non-Government Organisations',
   'nom', 'Personal names',
   'org', 'Non-Commercial Organisations',
   'school', 'schools',
   'tm', 'ownership of the trademark',
   'web', 'web server');
}


sub list_zw {# _domain
   ('co', 'Commercial');
}


sub list_lay {
   ('com','1', 'org','1', 'net','1', 'edu','1', 'gov','1', 'mil','1',

   'ac','1', 'ae','2', 'am','1', 'ar','2', 'as','1', 'at','2', 'au','2',
   'be','1', 'bg','1', 'bh','2', 'bm','1', 'bn','1', 'bo','2', 'br','2', 'bt','1',
   'ca','1', 'cc','1', 'ch','1', 'cl','1', 'cn','2', 'co','2', 'cx','1', 'cr','1', 'cz','1',
   'de','1', 'dk','1',
   'ec','2', 'ee','1', 'es','1',
   'fi','1', 'fk','2', 'fm','1', 'fr','1',
   'gr','1', 'gu','2',
   'hk','2', 'hr','1', 'hu','1',
   'id','2', 'ie','1', 'il','2', 'in','2', 'io','2', 'is','1', 'it','1',
   'jp','2',
   'kr','2',
   'lt','1', 'lu','1', 'lv','1',
   'mk','2', 'mn','1', 'mo','1', 'mr','1', 'mt','2', 'mx','1', 'my','1',
   'na','2', 'nl','1', 'no','1', 'np','2', 'nu','1', 'nz','2',
   'pe','2', 'pk','2', 'pl','2', 'pt','1', 'py','2',
   'qa','2',
   'ro','1', 'ru','1',
   'sa','2', 'se','1', 'sh','1', 'si','1', 'sk','1', 'sg','2', 'st','1',
   'th','2', 'tj','1', 'to','1', 'tm','1', 'tr','2', 'tw','2',
   'ua','1', 'uk','2', 'us','2',
   've','2', 'vn','2',
   'yu','1',
   'za','2', 'zm','1','zw','2');
}

1;
